var appConfig = {
    'isLessThanIE9' : false
};

/**
* Beinhalted übersetzte Texte
*/
var localizedStrings = {
    
    'de' : {
        
        'H300'   : 'Lebensgefahr bei Verschlucken.<br>(H300)',
        'H310'   : 'Lebensgefahr bei Hautkontakt. <br>(H310)',
        'H330'   : 'Lebensgefahr bei Einatmen. <br>(H330)',
        'H340'   : 'Kann genetische Defekte verursachen. (H340)',
        'H350'   : 'Kann (beim Einatmen) Krebs erzeugen. (H350)',
        'H360'   : 'Kann die Fruchtbarkeit beeinträchtigen / Kann das Kind im Mutterleib schädigen. (H360)',
        'H370'   : 'Schädigt die Organe. (H370)',
        'H372'   : 'Schädigt die Organe bei längerer oder wiederholter Exposition. (H372)',
        'H314'   : 'Verursacht schwere Verätzungen der Haut und schwere Augenschäden. (H314)',
        'H410KG' : 'Sehr giftig für Wasserorganismen mit langfristiger Wirkung <em class="red">Verpackungsinhalt > 1kg</em>. (H410)',
        'H250'   : 'Entzündet sich in Berührung mit Luft von selbst. (H250)',
        'H260'   : 'In Berührung mit Wasser entstehen entzündbare Gase, die sich spontan entzünden können, oder (H260)',
        'H261'   : 'In Berührung mit Wasser entstehen entzündbare Gase. (H261)',
        
        'EUH006' : 'Mit und ohne Luft explosionsfähig. (EUH006)',
        'EUH019' : 'Kann explosionsfähige Peroxide bilden. (EUH019)',
        'EUH029' : 'Entwickelt bei Berührung mit Wasser giftige Gase. (EUH029)',
        'EUH031' : 'Entwickelt bei Berührung mit Säure giftige Gase. (EUH031)',
        'EUH032' : 'Entwickelt bei Berührung mit Säure sehr giftige Gase. (EUH032)'
        
    } ,
    
    'fr'  :{
        'H300'   : 'Mortel en cas d’ingestion<br>(H300)',
        'H310'   : 'Mortel par contact cutané<br>(H310)',
        'H330'   : 'Mortel par inhalation<br>(H330)',
        'H340'   : 'Peut induire des anomalies génétiques<br>(H340)',
        'H350'   : 'Peut provoquer le cancer (par inhalation)<br>(H350)',
        'H360'   : 'Peut nuire à la fertilité ou au foetus<br>(H360)',
        'H370'   : 'Risque avéré d’effets graves pour les organes<br>(H370)',
        'H372'   : 'Risque avéré d’effets graves pour les organes à la suite d’expositions répétées ou d’une exposition prolongée.<br>(H372)',
        'H314'   : 'Provoque des brûlures de la peau et des lésions oculaires graves.<br>(H314)',
        'H410KG' : 'Très toxique pour les organismes aquatiques, entraîne des effets néfastes à long terme.& Verpackungsinhalt > 1Kg<br>(H410)',
        'H250'   : 'S’enflamme spontanément au contact de l’air<br>(H250)',
        'H260'   : 'Dégage au contact de l’eau des gaz inflammables qui peuvent s’enflammer spontanément, ou<br>(H260)',
        'H261'   : 'Dégage au contact de l’eau des gaz inflammables.<br>(H261)',
        
        'EUH006' : 'Dans d’explosion en contact ou sans contact avec l’air<br>(EUH006)',
        'EUH019' : 'Peut former des peroxydes explosifs<br>(EUH019)',
        'EUH029' : 'Au contact de l’eau, dégage des gaz toxiques<br>(EUH029)',
        'EUH031' : 'Au contact d’un acide, dégage un gaz toxique<br>(EUH031)',
        'EUH032' : 'Au contact d’un acide, dégage un gaz très toxique.<br>(EUH032)'       
    } ,
    'it' : {
        
        'H300'   : 'Mortale se ingerito<br>(H300)',
        'H310'   : 'Mortale a contatto con la pelle<br>(H310)',
        'H330'   : 'Mortale se inalato<br>(H330)',
        'H340'   : 'Può provocare alterazioni genetiche<br>(H340)',
        'H350'   : 'Può provocare il cancro (se inalato)<br>(H350)',
        'H360'   : 'Può nuocere alla fertilità / al feto<br>(H360)',
        'H370'   : 'Provoca danni agli organi<br>(H370)',
        'H372'   : 'Provoca danni agli organi in caso di esposizione prolungata o ripetuta<br>(H372)',
        'H314'   : 'Provoca gravi ustioni cutanee e gravi lesioni oculari<br>(H314)',
        'H410KG' : 'Molto tossico per gli organismi acquatici con effetti di lunga durata& Verpackungsinhalt > 1Kg<br>(H410)',
        'H250'   : 'Spontaneamente infiammabile all’aria<br>(H250)',
        'H260'   : 'A contatto con l’acqua libera gas infiammabili che possono infiammarsi spontaneamente, o <br>(H260)',
        'H261'   : 'A contatto con l’acqua libera gas infiammabili<br>(H261)',
        
        'EUH006' : 'Esplosivo a contatto o senza contatto con l’aria <br>(EUH006)',
        'EUH019' : 'Può formare perossidi esplosivi<br>(EUH019)',
        'EUH029' : 'A contatto con l’acqua libera un gas tossico<br>(EUH029)',
        'EUH031' : 'A contatto con acidi libera un gas tossico<br>(EUH031)',
        'EUH032' : 'A contatto con acidi libera un gas altamente tossico<br>(EUH032)'        
        
    }
}



/**
* Spezielles
*   Die Implementierung der Regelen (Excel Sheet) sind mit Rxx markiert
*   die Gefahrensymbole sind mit der id #ghs01 - #ghs09 im DOM abrufbar. Ausgewählte Symbole haben die css class 'selected'
* 
*   aufbau ():
*      view: in der funktion _viewWillAppear werden die view vorbereitet
* 
*   navigation:
*     es ist angedacht, dass die app einmal mittels hashtag navigiert werden kann. aus diesem grund sind die nacigationen goto(#resultat);
* 
* 
* 
*/


var appWindow = null;


jQuery(function($) {
    
    //
    appWindow = $('#window');
    
    
    
    calculateWidth();

    
    
    //adjust language 
    var queryLang = _GET('lang');
    if (queryLang === null) {
        queryLang = 'de';
    }
    if (!(queryLang == 'de' || queryLang=='it' ||queryLang=='fr')) 
        queryLang = 'de';
        
    setLanguage(queryLang);
    
    
    //auschhalten des titels
    var queryNavbar = _GET('notopbar');
    if (queryNavbar === '1') {
        $('.navbar').hide();
    }
    
    // xx start xx
    
    //- hide everyting first
    $('.view',appWindow).hide();
    
    //- gehe auf erste Seite
    navigateToUrl('#home',null);
    //navigateToUrl('#result',null);
    //navigateToUrl('#sentences',null);
    
    
    // - roter ('weiter') button am unteren rand jeder view
    $(appWindow).on('click','a.redbutton',function(e){
        e.preventDefault();
        
        if ($(this).hasClass('disabled')) {
            //button ist deakviert worden
            return false;
        }
        
        gotoNextView($(this));

        return false;
    });
    
    
    
    // - gefahrensymbole klick 
    $('.symbols', appWindow).on('click','a.ghs',function(e){
        e.preventDefault();
        
        $(this).toggleClass('selected'); //aktiv / inaktiv schalten
        
        //update weiter button state
        symbols_updateRedButton();
        
        return false;
    });
    
    
    // - H-Sätze klick
    /*
    $('.sentences', appWindow).on('change','input:checkbox',function(e){
        //alert('tick');
        
        
        // <no logic yet>
    });*/
    
    if (appConfig['isLessThanIE9'] == true) {
        //bei ie9 funktioniren die checkboxen nicht
        
        $('.sentences', appWindow).on('click','input:checkbox + label',function(e){
            
            var label = $(this);
            
            //simulate the click
            var input = $('#'+label.attr('for'));
            input.trigger('click');
            
            //IE lt9 doesn't support :checked, so give it the 'checked' class for our
            if (input.is(':checked')) {
                label.addClass('checked');
            } else {
                label.removeClass('checked');
            }
        });
        
    }
  
});



function calculateWidth()
{      
    
    if (typeof(_GET("width")) != 'undefined') {
        
        //adjust width if set
        var queryWidth = _GET("width");
        
        if (isNaN(queryWidth)) {
            
            if (queryWidth.indexOf("p") == 0) {
                
                var factor = parseInt(queryWidth.substr(1));
                queryWidth = jQuery(document).width() * (factor*1.0/100.0);
                if (queryWidth >= 320) {
                    appWindow.width(''+queryWidth+'px');
                }
            }             
            
        } else {
            queryWidth = Math.min(queryWidth, 800); //maximale breite
            queryWidth = Math.max(queryWidth, 320); //minimale breite
            appWindow.width(''+queryWidth+'px');               
        }
    
    
    
        /*
        var queryWidth = parseFloat(_GET('width'));
        if (!isNaN(queryWidth)) {
            console.log(queryWidth);

            
        
        } else {
                
        }  */ 
        
    }
}




function reinitApp()
{
    
    // - setze alle symbole auf deselected
    jQuery('.view.symbols a.ghs', appWindow).removeClass('selected');    
    
    // - sentences muss in grundmodus gesetzt werden
    jQuery('.view.sentences', appWindow).data('mode', 'first');
    
}


function symbols_updateRedButton()
{
    //aktualisiere den status des weiter buttons in der symbols view
    if ($('.symbols a.ghs.selected',appWindow).length > 0) {
        $('.symbols a.redbutton', appWindow).removeClass('disabled');
    } else {
        $('.symbols a.redbutton', appWindow).addClass('disabled');
    }    
}


/**
* 
* @param sentenceIds array mit sentence id
* @param sentenceBox container für die sätze
*/
function sentences_addCheckbox(sentenceIds, sentenceBox)
{
    
    jQuery.each(sentenceIds,function(index,sentenceId){

        if (sentenceBox.find('#ghs'+sentenceId+'').length > 0) {
            return true;//stellt sicher, dass eine id nur einmal vorkommt
        }
        
        var title = _LocalizedString(sentenceId);
        
        /*
        sentenceBox.append("<input id=\"ghs"+sentenceId+"\" name=\"ghs"+sentenceId+"\" type=\"checkbox\" />"+
                              "<label for=\"ghs"+sentenceId+"\"><span class=\"icon\"></span><span>"+title+"</span></label>");
        */
                              
        
        sentenceBox.append("<input id=\"ghs"+sentenceId+"\" name=\"ghs"+sentenceId+"\" type=\"checkbox\" />"+
                              "<label for=\"ghs"+sentenceId+"\"><table width=\"100%\"><tr><td class=\"icon\"></td><td class=\"label\">"+title+"</td></tr></table></label>");
                              
                              
    });
}

/**
* setzten des resultats
* 
* 
* 
* @param result - group1 / group2 / default
*/
function setResult(result , enableAddonText)
{
    if (enableAddonText === undefined) enableAddonText = false;
    
    
    /*
    if (result != 'group1')  $(".view.result .group.group1").hide();
    if (result != 'group2')  $(".view.result .group.group2").hide();
    if (result != 'default') $(".view.result .group.default").hide();
    */
    
    $(".view.result .group").hide();//hide all
    
    var elementsToShow = $(".view.result .group."+result+"[lang='"+selectedLanguage+"']");
    elementsToShow.show();
    if (enableAddonText==true) {
        elementsToShow.find('.addon').show();
    } else {
        elementsToShow.find('.addon').hide();
    }
    
    //$(".view.result .group."+result+"[lang='"+selectedLanguage+"']").show(); //enable one
    
}

/**
* prüft den aktuellen view status und bereitet die nächste view vor
* 
* @param sender der button, welcher die funktion ausgelöst hat
*/
function gotoNextView(sender)
{
    
    
    
    //
    var currentView = sender.parents('.view');
    
    if (currentView.hasClass('symbols')) {
        
        
        //direkte regeln, ohne auswahl von h-sätzen
        
        var isGHS01 = jQuery('#ghs01').hasClass('selected');
        var isGHS06 = jQuery('#ghs06').hasClass('selected');
        var isGHS07 = jQuery('#ghs07').hasClass('selected');

        
        //REGEL - R01
        if (isGHS01) {
            setResult('group1');
            navigateToUrl('#result', sender);
            return true;
        }
        
       
        
        
    }
    
    
    
    
    //im sentences view gibt es noch zwischenschritte...
    if (currentView.hasClass('sentences')) {
        
        var isGHS02 = jQuery('#ghs02').hasClass('selected');
        var isGHS05 = jQuery('#ghs05').hasClass('selected');
        var isGHS06 = jQuery('#ghs06').hasClass('selected');
        var isGHS07 = jQuery('#ghs07').hasClass('selected');
        var isGHS09 = jQuery('#ghs09').hasClass('selected');
        
        
        var result = '';
        var enableAddon = false;
        do {
            
            
        
            if (isGHS06) {
                
                //totenkopf.vsd
                result = 'group2';  //default gruppe in diesem schema
            
            
                //R02 R03 R04
                if (isGHS06 && jQuery('#ghsH300, #ghsH310, #ghsH330').is(':checked')) {
                    result = 'group1'
                    break;
                }
                
                //R05
                if (isGHS06 && !isGHS07) {
                    result = 'group2';
                    enableAddon = true;
                    break;
                } 
                                
                if (isGHS06 && isGHS07) {
                    
                    if (jQuery('#ghsH340, #ghsH350, #ghsH360').is(':checked')) {
                        //R06 R07 R08
                        //ist eines markiert?
                        result = 'group1';
                    } else {
                        //R09 R10 R11
                        result = 'group2';
                        enableAddon = true;
                    }
                    break;
                }                
            
            
            
            } else {
                
                // lunge.vsd
                result = 'default';
                
                
                
                
                if (currentView.data('mode') == 'first') {
                
                
                    //R12 R13 R14
                    if (isGHS07 && jQuery('#ghsH340, #ghsH350, #ghsH360').is(':checked')) {
                    
                        result = 'group1';
                        break;
                    }
                    //R15 R16
                    if (isGHS07 && jQuery('#ghsH370, #ghsH372').is(':checked')) {
                        
                        result = 'group2';
                        enableAddon = true;
                        break;
                    }                
                
                    //R17
                    if (isGHS05 && jQuery('#ghsH314').is(':checked')) {
                        result = 'group2';
                        break;                    
                    }
                
                    //R18
                    if (isGHS09 & jQuery('#ghsH410KG').is(':checked')) {
                        result = 'group2';
                        break;                    
                    } 
                
                    //R19 R20 R21
                    if (isGHS02 & jQuery('#ghsH250, #ghsH260, #ghsH261').is(':checked')) {
                        result = 'group2';
                        break;                    
                    }                 
                
                
                    // - wenn die anzahl selektierter sätze zero ist, dann fragen wir noch nach den EUHS Sätzen
                    currentView.data('mode', 'euh');
                    navigateToUrl('#sentences', sender); 
                
                    return true; 
                    
                    
                    
               
                
                
                } else if (currentView.data('mode') == 'euh') {
                    
                    if (jQuery('#ghsEUH006, #ghsEUH019, #ghsEUH029, #ghsEUH031, #ghsEUH032').is(':checked')) {
                        result = 'group2';
                        break;
                    } 
                    
                }
            
            }
            
        
        
        
        } while(false);
        
        
        setResult(result, enableAddon); //oder was zutrifft...
        navigateToUrl('#result', sender);
        
        return true;
        
        
        /*
        //if sentence_step = primary & selecteditems.count > 0
        if (currentView.data('mode') == 'first') {
            
            //bedingt, dass während 'first' nur euh-sätze aufgelistet werden, sonst müsste man hier
            //  einzeln prüfen
            if(jQuery('.sentencebox :checked', currentView).length > 0) {
                

                //ein EUH Satz ist auf dem Produkt -> Gruppe 2
                
                // R24 R25 R26 R27 R28
                setResult('group2');
                navigateToUrl('#result', sender);                
                return true;    
            } 
            
            
            //wir sind auf der ersten view, der user hat aber keine option markiert -> loop
            currentView.data('mode', 'second');
            navigateToUrl('#sentences', sender); 
                           
            return true;          
        
        
        } if (currentView.data('mode') == 'second') {
            
           
            
            //regelwerk...
            
            var isGHS02 = jQuery('#ghs02').hasClass('selected');
            var isGHS05 = jQuery('#ghs05').hasClass('selected');
            var isGHS06 = jQuery('#ghs06').hasClass('selected');
            var isGHS07 = jQuery('#ghs07').hasClass('selected');
            var isGHS09 = jQuery('#ghs09').hasClass('selected');            
            
            
            //default rule..
            var result = 'default';
            
            do {
                
                

                //R02 R03 R04
                if (isGHS06 && jQuery('#ghsH300, #ghsH310, #ghsH330').is(':checked')) {
                    result = 'group1'
                    break;
                }
                
                
                if (isGHS06 && isGHS07) {
                    
                    if (jQuery('#ghsH340, #ghsH350, #ghsH360').is(':checked')) {
                        //R06 R07 R08
                        //ist eines markiert?
                        result = 'group1';
                    } else {
                        //R09 R10 R11
                        result = 'group2';
                    }
                    break;
                }
                
                //R12 R13 R14
                if (isGHS07 && jQuery('#ghsH340, #ghsH350, #ghsH360').is(':checked')) {
                    
                    result = 'group1';
                    break;
                }
                //R15 R16
                if (isGHS07 && jQuery('#ghsH370, #ghsH372').is(':checked')) {
                    
                    result = 'group2';
                    break;
                }                
                
                
                //R17
                if (isGHS05 && jQuery('#ghsH314').is(':checked')) {
                    result = 'group2';
                    break;                    
                }
                
                //R18
                if (isGHS09 & jQuery('#ghsH410KG').is(':checked')) {
                    result = 'group2';
                    break;                    
                } 
                
                //R19 R20 R21
                if (isGHS02 & jQuery('#ghsH250, #ghsH260, #ghsH261').is(':checked')) {
                    result = 'group2';
                    break;                    
                }                                 
                
                
            } while(false);
            
            
            setResult(result); //oder was zutrifft...
            navigateToUrl('#result', sender);
            return true;
            
        }
        */
        
        
        
    }
    
        
    
    //im normalfall
    navigateToUrl(sender.attr('href'), sender);    
}


function isSentenceSelected(sentenceId) {
    return jQuery('#ghs'+sentenceId+'').is(':checked');
}



function navigateToUrl(url, sender)
{
    
    var currentView = jQuery('.view',appWindow).not(':hidden');
    
    
    
    
    if (url == '#home') {
        if(currentView.length > 0) {
            hideView(currentView); //Neustart
            
            
            reinitApp();
            

            
            
        } else {
            //erster aufruf der app.
        }
        showView('home', true);
        
    } else if (url == '#symbols') {
        
        hideView(currentView);
        showView('symbols', true);
        
        
    } else if (url == '#sentences') {
        
        hideView(currentView);
        showView('sentences', true);        
        
        
    } else if (url == '#result') {
        
        hideView(currentView);
        showView('result', true);        
        
    }
    
}


function hideView(view)
{
    //var view = jQuery('.'+viewName+'',appWindow);
    view.hide();
}

function showView(viewName,animated)
{   
    if (animated === undefined) animated = true;
    
    var view = jQuery('.'+viewName+'',appWindow);
    
    _viewWillAppear(view);
    
    if (animated == true) {
        view.fadeIn(200, function(e) {
            _viewDidAppear(view);
        });        
    } else {
        view.show();
        _viewDidAppear(view);
    }

}


/**
* Die view wird demänchst angezeigt, es wäre gut, wenn 
*   wir hier die view mit den richtigen daten aktualiseren
* 
* @param view
*/
function _viewWillAppear(view)
{
    //init
    
    
    //
    if (view.hasClass('symbols')) {
        
        //update button state
        symbols_updateRedButton();
            
    } if (view.hasClass('sentences')) {
        
        //leere bestehnde sätze
        var sentenceBox = jQuery('.sentencebox', view);
        sentenceBox.empty();        
        //return;

        
        
        //euh - load
        var mode = view.data('mode');
        
        if (mode == 'euh') {
            
            //EUH Sätze haben die stärkste Filterwirkung
            sentences_addCheckbox(['EUH006','EUH019','EUH029','EUH031','EUH032'], sentenceBox);
            
        } else {
        
        
            // finde mögliche H-Sätze für die darstellung abhängig von den ausgewählten gefahrensymbolen
            var s = new Array();
        
        
        
        
            var isGHS02 = jQuery('#ghs02').hasClass('selected');
            var isGHS05 = jQuery('#ghs05').hasClass('selected');
            var isGHS06 = jQuery('#ghs06').hasClass('selected');
            var isGHS07 = jQuery('#ghs07').hasClass('selected');
            var isGHS09 = jQuery('#ghs09').hasClass('selected');        
        
        
            if (isGHS06) {
            
                //totenkopf.vsd
            
                //R02 R03 R04
                s.push('H300','H310','H330');
             
                if (isGHS07) {
                    //R06 R07 R08 R09 R10 R11
                    s.push('H340','H350','H360');                    
                }            
            
            
            } else {
            
            
            
                //lunge.vsd
                if (isGHS07) {
                    //R12 R13 R14 R15 R16
                    s.push('H340', 'H350','H360','H370','H372');
                }                   
            
                if (isGHS05) {
                    //R17
                    s.push('H314');
                }       
                     
                if (isGHS09) {
                    //R18
                    s.push('H410KG');
                }                   
            
                if (isGHS02) {
                    //R19 R20 R21
                    s.push('H250','H260','H261');
                }
                
            
            
                //es könnte nun sein, dass keine sätze vorhanden sind aufgrund der kombinationen
                // -> direkt EUH-Sätze fragen
                if(s.length < 1) {
                    
                    view.data('mode', 'euh');
                    //navigateToUrl('#sentences', sender);                    
                    s.push('EUH006','EUH019','EUH029','EUH031','EUH032');
                    
                }
            
            
            }
        
            //füge die Sätze hinzu
            sentences_addCheckbox(s, sentenceBox);
        
        
        /*
        //first load
        var mode = view.data('mode');
        if (mode == 'first') {
            //EUH Sätze haben die stärkste Filterwirkung
            
            sentences_addCheckbox(['EUH006','EUH019','EUH029','EUH031','EUH032'], sentenceBox);
            
            
            
        } else if (mode == 'second') {
            
            //zweiter aufruf
            
            // finde mögliche H-Sätze für die darstellung abhängig von den ausgewählten gefahrensymbolen
            var s = new Array();
            
            var isGHS02 = jQuery('#ghs02').hasClass('selected');
            var isGHS05 = jQuery('#ghs05').hasClass('selected');
            var isGHS06 = jQuery('#ghs06').hasClass('selected');
            var isGHS07 = jQuery('#ghs07').hasClass('selected');
            var isGHS09 = jQuery('#ghs09').hasClass('selected');
            
            
            if (isGHS06) {
                //Totenkopf.vsd
                
                //R02 R03 R04
                s.push('H300','H310','H330');
                
                
                if (isGHS07) {
                    //R06 R07 R08 R09 R10 R11
                    s.push('H340','H350','H360');                    
                }
                
                
            } else {
                //Lunge.vsd  <=> !isGHS06
                
            
                if (isGHS07) {
                    //R12 R13 R14 R15 R16
                    s.push('H340', 'H350','H360','H370','H372');
                }                   
                
                if (isGHS05) {
                    //R17
                    s.push('H314');
                }       
                         
                if (isGHS09) {
                    //R18
                    s.push('H410KG');
                }                   
                
                if (isGHS02) {
                    //R19 R20 R21
                    s.push('H250','H260','H261');
                }                 
                
            }
            
            
            
            sentences_addCheckbox(s, sentenceBox);
            
            
        }
         
        */
        

        
        
        }

        
        
        
        
        
    }
    
}




function _viewDidAppear(view)
{
    
}



var selectedLanguage = null;
function setLanguage(lang)
{
    if (selectedLanguage == lang) {
        return;
    }
    
    selectedLanguage = lang;
    
    if (lang != 'de') $("[lang='de']").hide();
    if (lang != 'fr') $("[lang='fr']").hide();
    if (lang != 'it') $("[lang='it']").hide();
    
    $("[lang='"+lang+"']").show();
}






function _LocalizedString(stringKey)
{
    
    try {
        
        
        var translation = localizedStrings[selectedLanguage][stringKey];
        if (translation === undefined) {
            
            return stringKey;
        }
        return translation;
        
    } catch (e){}
    
    return ''+stringKey;    
    
}
    
    
// find get variable in URL string
function _GET(name) {
    
    return unescape((RegExp(name + '=' + '(.+?)(&|$)').exec(location.search)||[,null])[1]);
    
}

if (window.addEventListener) {
    
    window.addEventListener("orientationchange", function() {
        calculateWidth()
    }, false);
}